---
title: CanvasRenderingContext2D.rotate()
slug: Web/API/CanvasRenderingContext2D/rotate
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.rotate()</code></strong> method of the Canvas 2D API adds a rotation to the transformation matrix.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.rotate(<em>angle</em>);
</pre>

<p><img alt="" class="internal" src="https://mdn.mozillademos.org/files/233/Canvas_grid_rotate.png" style="float: right;"></p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>angle</code></dt>
 <dd>The rotation angle, clockwise in radians. You can use <code><em>degree</em> * Math.PI / 180</code> to calculate a radian from a degree.</dd>
</dl>

<p>The rotation center point is always the canvas origin. To change the center point, you will need to move the canvas by using the {{domxref("CanvasRenderingContext2D.translate", "translate()")}} method.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Rotating_a_shape">Rotating a shape</h3>

<p>This example rotates a rectangle by 45°. Note that the center of rotation is the top-left corner of the canvas, and not a location relative to any shape.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[14]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Point of transform origin
ctx.arc(0, 0, 5, 0, 2 * Math.PI);
ctx.fillStyle = 'blue';
ctx.fill();

// Non-rotated rectangle
ctx.fillStyle = 'gray';
ctx.fillRect(100, 0, 80, 20);

// Rotated rectangle
ctx.rotate(45 * Math.PI / 180);
ctx.fillStyle = 'red';
ctx.fillRect(100, 0, 80, 20);

// Reset transformation matrix to the identity matrix
ctx.setTransform(1, 0, 0, 1, 0, 0);
</pre>

<h4 id="Result">Result</h4>

<p>The <span style="color: blue;">center of rotation is blue</span>. The <span style="color: gray;">non-rotated rectangle is gray</span>, and the <span style="color: red;">rotated rectangle is red</span>.</p>

<p>{{ EmbedLiveSample('Rotating_a_shape', 700, 180) }}</p>

<h3 id="Rotating_a_shape_around_its_center">Rotating a shape around its center</h3>

<p>This example rotates a shape around its center point. To do this, the following steps are applied to the matrix:</p>

<ol>
 <li>First, {{domxref("CanvasRenderingContext2D.translate()", "translate()")}} moves the matrix's origin to the shape's center.</li>
 <li><code>rotate()</code> rotates the matrix by the desired amount.</li>
 <li>Finally, <code>translate()</code> moves the matrix's origin back to its starting point. This is done by applying the values of the shape's center coordinates in a negative direction.</li>
</ol>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The shape is a rectangle with its corner at (80, 60), a width of 140, a height of 30. Its horizontal center is at (80 + 140 / 2), or 150. Its vertical center is at (60 + 30 / 2), or 75. Thus, the center point is at (150, 75).</p>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Non-rotated rectangle
ctx.fillStyle = 'gray';
ctx.fillRect(80, 60, 140, 30);

// Matrix transformation
ctx.translate(150, 75);
ctx.rotate(Math.PI / 2);
ctx.translate(-150, -75);

// Rotated rectangle
ctx.fillStyle = 'red';
ctx.fillRect(80, 60, 140, 30);
</pre>

<h4 id="Result_2">Result</h4>

<p>The <span style="color: gray;">non-rotated rectangle is gray</span>, and the <span style="color: red;">rotated rectangle is red</span>.</p>

<p>{{ EmbedLiveSample('Rotating_a_shape_around_its_center', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-rotate", "CanvasRenderingContext2D.rotate")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.rotate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
